from cy_ioc_extract.patterns import IP_REGEX, DOMAIN_REGEX, FIND_EMAIL_REGEX, CVE_REGEX, URL_REGEX, SHA256_REGEX, \
    MD5_REGEX, SHA1_REGEX, UUID_REGEX, IPv4_CIDR, IPv6_REGEX, SHA224_REGEX, SHA384_REGEX, SHA512_REGEX, SSDEEP_REGEX, \
    DIRECTORY_REGEX, FILE_PATH_REGEX, AUTONOMOUS_SYSTEM_REGEX, WINDOWS_REGISTRY_KEY, MAC_ADDRESS_REGEX, \
    VALID_HOST_REGEX, WHIRLPOOL_REGEX, SHA3512_REGEX, SHA3384_REGEX, SHA3256_REGEX, SHA3224_REGEX, EMAIL_REGEX
from validator.validators import validate_domains

# ALL_REGEX = {
#     "IP_REGEX": IP_REGEX,
#     "DOMAIN_REGEX": DOMAIN_REGEX,
#     "EMAIL_REGEX": DOMAIN_REGEX,
#     "FIND_EMAIL_REGEX": FIND_EMAIL_REGEX,
#     "CVE_REGEX": CVE_REGEX,
#     "URL_REGEX": URL_REGEX,
#     "SHA256_REGEX": SHA256_REGEX,
#     "MD5_REGEX": MD5_REGEX,
#     "SHA1_REGEX": SHA1_REGEX,
#     "UUID_REGEX": UUID_REGEX,
#     "IPv4_CIDR": IPv4_CIDR,
#     "IPv6_REGEX": IPv6_REGEX,
#     "SHA224_REGEX": SHA224_REGEX,
#     "SHA384_REGEX": SHA384_REGEX,
#     "SHA512_REGEX": SHA512_REGEX,
#     "SSDEEP_REGEX": SSDEEP_REGEX,
#     "DIRECTORY_REGEX": DIRECTORY_REGEX,
#     "FILE_PATH_REGEX": FILE_PATH_REGEX,
#     "AUTONOMOUS_SYSTEM_REGEX": AUTONOMOUS_SYSTEM_REGEX,
#     "WINDOWS_REGISTRY_KEY": WINDOWS_REGISTRY_KEY,
#     "MAC_ADDRESS_REGEX": MAC_ADDRESS_REGEX,
#     "VALID_HOST_REGEX": VALID_HOST_REGEX,
#     "WHIRLPOOL_REGEX": WHIRLPOOL_REGEX,
#     "SHA3512_REGEX": SHA3512_REGEX,
#     "SHA3384_REGEX": SHA3384_REGEX,
#     "SHA3256_REGEX": SHA3256_REGEX,
#     "SHA3224_REGEX": SHA3224_REGEX,
# }

ALL_REGEX = {
    "IP": {"regex": IP_REGEX},
    "DOMAIN": {"regex": DOMAIN_REGEX, "validator": validate_domains},
    "EMAIL": {"regex": EMAIL_REGEX},
    "FIND_EMAIL": {"regex": FIND_EMAIL_REGEX},
    "CVE": {"regex": CVE_REGEX},
    "URL": {"regex": URL_REGEX},
    "SHA256": {"regex": SHA256_REGEX},
    "MD5": {"regex": MD5_REGEX},
    "SHA1": {"regex": SHA1_REGEX},
    "UUID": {"regex": UUID_REGEX},
    "IPv4_CIDR": {"regex": IPv4_CIDR},
    "IPv6": {"regex": IPv6_REGEX},
    "SHA224": {"regex": SHA224_REGEX},
    "SHA384": {"regex": SHA384_REGEX},
    "SHA512": {"regex": SHA512_REGEX},
    "SSDEEP": {"regex": SSDEEP_REGEX},
    "DIRECTORY": {"regex": DIRECTORY_REGEX},
    "FILE_PATH": {"regex": FILE_PATH_REGEX},
    "AUTONOMOUS_SYSTEM": {"regex": AUTONOMOUS_SYSTEM_REGEX},
    "WINDOWS_REGISTRY_KEY": {"regex": WINDOWS_REGISTRY_KEY},
    "MAC_ADDRESS": {"regex": MAC_ADDRESS_REGEX},
    "VALID_HOST": {"regex": VALID_HOST_REGEX},
    "WHIRLPOOL": {"regex": WHIRLPOOL_REGEX},
    "SHA3512": {"regex": SHA3512_REGEX},
    "SHA3384": {"regex": SHA3384_REGEX},
    "SHA3256": {"regex": SHA3256_REGEX},
    "SHA3224": {"regex": SHA3224_REGEX},
}

ALL_EXTRACT_FIELDS = list(ALL_REGEX.keys())

ERRORS = {
    "invalid_field_to_extract": "Invalid fields %s given to extract. Supported types are %s."
}
