from validator.constants import ALL_TLDS


def validate_domains(domains):
    """Validate domains against IANA and Custom TLDs(Some Open NIC domains)"""
    valid_domains = set({})
    for domain in domains:
        try:
            tld = f""".{domain.split(".")[-1]}"""
            if tld in ALL_TLDS:
                valid_domains.add(domain)
        except Exception:
            pass
    return list(valid_domains)